library Artsampl;
uses WinTypes,WinProcs,Messages;

{$R password.res}

var UserEdit : array [0..99] of Char;
const INIFile: array [0..20] of Char = '.\artshop.ini';

function StrCopy(Dest, Source: PChar): PChar; assembler;
asm
        PUSH    DS
        CLD
        LES     DI,Source
        MOV     CX,0FFFFH
        XOR     AL,AL
        REPNE   SCASB
        NOT     CX
        LDS     SI,Source
        LES     DI,Dest
        MOV     AX,DI
        MOV     DX,ES
        REP     MOVSB
        POP     DS
end;

function StrPas(Str: PChar): String; assembler;
asm
        PUSH    DS
		CLD
        LES     DI,Str
        MOV     CX,256
        XOR     AL,AL
        REPNE   SCASB
        NOT     CL
        LDS     SI,Str
        LES     DI,@Result
        MOV     AL,CL
        STOSB
        REP     MOVSB
        POP     DS
end;


procedure YieldAppToDLL;
var MSG: TMsg;
	Handle: THandle;
begin
	Handle := 0;
	while PeekMessage(Msg,Handle, 0, 0, PM_REMOVE) = True do
		if(Msg.message = 18) then PostQuitMessage(0) else begin
			TranslateMessage(Msg);
			DispatchMessage(Msg);
		end;
end;


function IsRegged: Bool;Export;
var Password: array [0..20] of Char;
begin
	IsRegged := False;
{First check to see if permanent password is entered}
	GetPrivateProfileString('Defaults','UserID','',Password,SizeOf(Password),INIFile);
	If StrPas(Password) = StrPas('B45DE94') then IsRegged := True else IsREgged := False;
end;
exports IsRegged index 8;

function About(Dialog: HWnd; Message, WParam: Word; LParam: Longint): Bool; export;
begin
	About := True;
	case Message of
		wm_InitDialog: Exit;
		wm_Command: begin
			if (WParam = id_Ok) or (WParam = ID_Cancel) then begin
				GetDlgItemText(Dialog,106,UserEdit,SizeOf(UserEdit));
				EndDialog(Dialog, 1);
				Exit;
			end;
		end;
	end;
	About := False;
end;


procedure RegisterIt;export;
var Myproc: TFarproc;
	UserID: array [0..20] of Char;
	Cryptkey: array [0..29] of Char;
	i1: integer;
label RetryPass;
begin
{Decrypt password}

{Now check against encrypted string}
	GetPrivateProfileString('Defaults','UserID','',UserID,SizeOf(UserID),INIFile);
{Match strings}
	If StrPas(UserID) = StrPas('B45DE94') then begin
		MessageBox(GetActiveWindow,'Apparently Art Shop is already registered. '
			+'If you are having difficulties extracting images, contact the '
			+'publisher in regard to a possible bug fix or product support if '
			+'the problem persists.','Registration dialog aborted',64);
		Exit;
	end;
{Load the dialog...obviously not a match}
Retrypass:
	Myproc := MakeProcInstance(@About,hInstance);
	DialogBox(hInstance,'CustEditBox',GetActiveWindow,Myproc);
	FreeProcInstance(MyProc);
{Now do conditional actions}
	If StrPas(UserEdit) <> StrPas('Frame Dog') then begin
		   i1 := MessageBox(GetActiveWindow,'Incorrect password entered.'+#10#10
				+'Would you like to try again?','Registration unsuccessful',
				48 + MB_YESNO);
			If i1 = ID_YES then goto Retrypass else Exit;
	end else begin
		WritePrivateProfileString('Defaults','UserID','B45DE94',INIFile);
		MessageBox(GetActiveWindow,'Art Shop has been successfully registered. '
			+'The image extractor and the bitmap command string copy-to-clipboard '
			+'functions should now work as expected.','Registration successful',64);
	end;
YieldAppToDll;
end;
exports RegisterIt index 10;



procedure ASMSG; export;
begin
	MessageBox(GetActiveWindow,
		 'The image has been extracted to the Art Shop directory. '
		+'The corresponding bitmap command string has been copied to '
		+'the clipboard. Copy the image to your project''s bitmap '
		+'directory and insert the command string or select the image '
		+'into your RTF source document.','Bitmap command string copied',64);
end;
exports ASMSG index 5;

procedure AS256;export;
var i1: integer;
	P1: PChar;
begin
	i1 :=MessageBox(GetActiveWindow,
		 'Image extracted to the Art Shop directory; bitmap command '
		+'string copied to clipboard.'+#10
		+'Copy this file to the project''s bitmap directory '
		+'and paste the command string or select the image '
		+'into your source document.' + #10#10
		+'Additional hints for 256 color images?',
		'Bitmap command string copied',64 + MB_YESNOCANCEL);
	if i1 = ID_YES then begin
		i1 := MessageBox(GetActiveWindow,
			 '256 color images require a DLL for proper display in 16 '
			+'bit Help projects and must be referenced as embeddings. '+#10+#10
			+'Is this image destined for a 16 bit Help project?',
			+'256 color image hints',32 + MB_YESNOCANCEL);
	end;
	If I1 = ID_YES then begin
		Messagebox(GetActiveWindow,'Next you must insure that your '
			+'source document includes correct embedding syntax. '
			+'Help Magician will automatically format images selected '
			+'as embeddings. '+#10#10
			+'Regardless of your authoring tool, insure that the '
			+'required DLL is shipped '
			+'with your helpfile.','256 color image hints',64);
			Exit;
	end;
	If I1 =ID_NO then begin
		i1 := MessageBox(GetActiveWindow,
			 '32 bit Winhelp can display 256 '
			+'color images without extension software, but '
			+'be aware that ''palette shift'' is a common problem with '
			+'256 color images in WINHLP32.EXE on systems using 256 '
			+'color display drivers.'+#10#10
			+'Do you need to know what palette shift is?',
			 '256 color image hints',64+MB_YESNO);
	end;
	If i1 = ID_NO then Exit;
	If i1 = ID_YES then begin
		MessageBox(GetActiveWindow,
			 'Palette shift is an ugly repaletting effect '
			+'which distorts the appearance of images. It is difficult to '
			+'impossible to avoid without the use of a 32 bit Help DLL '
			+'designed for image display.'+#10+#10
			+'Would you like to know how to test for palette shift?',
			 '256 color image hints',64 + MB_YESNO);
	end;
	If i1 = ID_YES then begin
			MessageBox(GetActiveWindow,
			+' 1. Switch to 256 colors'+#10
			+' 2. Start your Web browser and load an image-rich site'+#10
			+' 3. Open the compiled .HLP containing your 256 color image'+#10
			+' 4. Alt+tab between Help and your browser with each new link.'+#10
			+'If/when palette-shift occurs, you''ll know it instantly.',
			 'To test for palette shift:',64);
	end;
end;
exports AS256 index 6;

procedure NOREG;export;
begin
	MessageBox(GetActiveWindow,
		 'Extraction of images is not available in unregistered '
		+'versions of Art Shop. The extraction feature will be '
		+'implemented upon entry of a valid registration code. '
		+'If you have not yet entered your registration code, '
		+'do so now using the RegKey button on the '
		+'button bar.','Unregistered version reminder',64);
end;
exports NOREG index 7;

Function WHMB (wnd : Longint; messagetext, messagecaption: PChar;
	messageflags: Integer) : Bool; Export;
begin
	case MessageBox (GetActiveWindow, messagetext, messagecaption, messageflags) of
		idOK, idYes, idRetry : WHMB:= True;
		idCancel, idAbort, idNo, idIgnore : WHMB:= False;
	end;
end;
exports WHMB index 1;

procedure WHSCD(Cliptext: PChar); Export;
var	hLoc: THandle;
var c2: array [0..255] of Char;
var	Messagestring: string;
	Tildeval: integer;
begin
	StrCopy(C2,Cliptext);
	If EmptyClipboard = False then CloseClipboard;
	If OpenClipboard(GetActiveWindow) = True Then Begin
		hLoc := GlobalAlloc( GHND, SizeOf(C2) + 1);
		strcopy(GlobalLock(hLoc), C2);
		GlobalUnlock( hLoc );
		SetClipboardData( CF_TEXT, hLoc );
		CloseClipboard;
	YieldAppToDll;
	end;
end;
exports WHSCD index 2;

var SaveExit : pointer;

  procedure DLLExitProc; far;
  begin
	ExitProc := SaveExit;
	{ WEP & cleanup }
  end;

begin
  SaveExit := ExitProc;
  ExitProc := @DLLExitProc;
end.

