unit mbcode;

interface

uses
  SysUtils, WinTypes, WinProcs, Controls, Forms,
	Classes, StdCtrls,Utils;

var
	MBType, MessageContent, MessageCaption, RegType,
		MessageMacros, FunctionName, MsgMacros,
		MBMacro1,MBMacro2,Opt321,opt322: String;
		MBITEFlag, MBMacFlag, MBVal, MBFlag1, MBFlag2: Integer;

type
  TWHMB = class(TForm)
	Preview: TEdit;
	Label1: TLabel;
	GroupBox1: TGroupBox;
	GroupBox4: TGroupBox;
	BCancel: TButton;
	Clipcopy: TButton;
	Showme: TButton;
	IconType: TComboBox;
	MBXType: TComboBox;
	Label2: TLabel;
	Labeel3: TLabel;
	Option1: TRadioButton;
	Option2: TRadioButton;
	Option3: TRadioButton;
	MBMacroString1: TEdit;
	MBMacroString2: TEdit;
	MsgCaption: TEdit;
	MsgContent: TEdit;
	MacroLabel1: TLabel;
	MacroLabel2: TLabel;
	Label6: TLabel;
	Label7: TLabel;
	CheckBox1: TCheckBox;
	Use32bit: TCheckBox;
	HintsOn: TCheckBox;
	CopyRR: TButton;
	Edit1: TEdit;
	procedure IconTypeChange(Sender: TObject);
	procedure ShowmeClick(Sender: TObject);
	procedure FormCreate(Sender: TObject);
	procedure MBMacroString1Change(Sender: TObject);
	procedure MBMacroString2Change(Sender: TObject);
	procedure MsgCaptionChange(Sender: TObject);
	procedure MsgContentChange(Sender: TObject);
	procedure CopyRRClick(Sender: TObject);
	procedure BCancelClick(Sender: TObject);
	procedure ClipcopyClick(Sender: TObject);
	procedure MBXTypeChange(Sender: TObject);
	procedure Option2Click(Sender: TObject);
	procedure Option3Click(Sender: TObject);
	procedure Option1Click(Sender: TObject);
	procedure CheckBox1Click(Sender: TObject);
	procedure HintsOnClick(Sender: TObject);
	procedure MsgCaptionExit(Sender: TObject);
	procedure MsgContentExit(Sender: TObject);
	procedure MBMacroString1Exit(Sender: TObject);
	procedure MBMacroString2Exit(Sender: TObject);
	procedure Use32bitClick(Sender: TObject);
  private
	{ Private declarations }
	procedure Update_MB;
	procedure MBPreview;
  public
	{ Public declarations }
  end;

var WHMB: TWHMB;
	INIFile: array [byte] of Char;
	Errorshown: Bool;
const Section: array [0..10] of Char = 'Defaults';

implementation

{$R *.DFM}

procedure TWHMB.IconTypeChange(Sender: TObject);
begin
	MBFlag1 := IconType.ItemIndex * 16;
	Update_MB
end;

procedure TWHMB.MBPreview;
begin
	Preview.Text := MBType + MessageContent + Chr(39) +',`' +
		MessageCaption + #39 + ',' + IntToStr(MBVal) + ')' + MessageMacros;
end;

procedure TWHMB.ShowmeClick(Sender: TObject);
var p1,p2: array [0..255] of char;
begin
	StrPCopy(p1,MessageContent);
	StrPCopy(p2,MessageCaption);
	MessageBox(Self.Handle,P1,P2,MBVal);
end;

procedure TWHMB.Update_MB;
begin
	If MBXType.ItemIndex = 0 Then begin
		Option1.Checked := True;
		Option2.Enabled := False;
		Option3.Enabled := False;
	end else begin
		Option2.Enabled := True;
		Option3.Enabled := True;
	end;
	If MBMacFlag = 0 Then MBType := FunctionName + '(0,`';
	If MBMacFlag = 1 Then MBType := 'IfThen(' + FunctionName + '(0,`';
	If MBMacFlag = 2 Then MBType := 'IfThenElse(' + FunctionName + '(0,`';
	If MBMacFlag = 0 Then MsgMacros := '';
	If MBMacFlag = 1 Then MsgMacros := ' , ' + Opt321 + MBMacro1 + Opt322 + ')';
	If MBMacFlag = 2 Then MsgMacros := ' , ' + Opt321 + MBMacro1 + Opt322 + ', ' + Opt321 + MBMacro2 + Opt322 +')';
	MBVal := MBFlag1 + MBFlag2;
	Preview.Text := MBType+MessageContent + #39 +',`'+MessageCaption+ #39 +',' + IntToStr(MBVal) + ')' + MsgMacros;
end;


procedure TWHMB.FormCreate(Sender: TObject);
var P1: array [byte] of Char;
begin
{Set INIfile}
	StrPCopy(INIFile,ChangeFileExt(ExpandFileName(Application.Exename),'.INI'));
	Font.Name := 'System';
{Set hinting}
	GetPrivateProfileString(Section,'Hints','',P1,SizeOf(P1),INIFile);
	If StrPas(P1) = StrPas('Off') Then begin
		Application.ShowHint := False;
		Hintson.Checked := False;
	end else begin
		Application.ShowHint := True;
		Hintson.Checked := True;
	End;
{Set variables}
	Opt321 := '`';
	Opt322 := #39;
	RegType := 'u=USSU';
	FunctionName := 'WHMessageBox';
	MBXType.Items.Add('Simple OK message');
	MBXType.Items.Add('OK and Cancel buttons');
	MBXType.Items.Add('Abort/Retry/Ignore buttons');
	MBXType.Items.Add('Yes, No and Cancel buttons');
	MBXType.Items.Add('Yes and No buttons');
	MBXType.Items.Add('Retry and Cancel buttons');
	MBXType.ItemIndex := 0;
	IconType.Items.Add('(no icon)');
	IconType.Items.Add('Stop icon');
	IconType.Items.Add('Question mark icon (?)');
	IconType.Items.Add('Exclamation mark icon (!)');
	IconType.Items.Add('Information icon (i)');
	IconType.ItemIndex := 0;
	MBType := FunctionName + '(hwndContext,`';
	MBVal := 0;
	MBMacFlag := 0;
	Update_MB;
end;

procedure TWHMB.MBMacroString1Change(Sender: TObject);
begin
	If (Errorshown = False) and (Semivalidate(MBMacrostring1.Text) = False)
		then ErrorShown := True;
	MBMacro1 := MBMacroString1.Text;
	Update_MB;
end;

procedure TWHMB.MBMacroString2Change(Sender: TObject);
begin
	Semivalidate(MBMacrostring2.Text);
	MBMacro2 := MBMacroString2.Text;
	Update_MB;
end;

procedure TWHMB.MsgCaptionChange(Sender: TObject);
begin
	If (Errorshown = False) and (StringValidate(MsgCaption.Text) = False)
		then ErrorShown := True;
	MessageCaption := MsgCaption.Text;
	Update_MB;
end;

procedure TWHMB.MsgContentChange(Sender: TObject);
begin
	If (Errorshown = False) and (StringValidate(MsgContent.Text) = False)
		then ErrorShown := True;
	MessageContent := MsgContent.Text;
	Update_MB;
end;

procedure TWHMB.CopyRRClick(Sender: TObject);
var s1,s2: string;
	p1: array[byte] of Char;
begin
	If FunctionName = 'WHMB' then
		S1 := 'RR(' else
		S1 := 'RegisterRoutine(';
	If Use32bit.Checked = True Then
		s2 := '`si32help.dll' + #39 + ',`'
		else s2 := '`si16help.dll' + #39 + ',`';
	Edit1.Text := S1 + S2 + FunctionName + #39 + ',`u=USSu' + #39 + ')';
	Edit1.SelectAll;
	Edit1.CopyToClipboard;
	MessageBox(Self.Handle,'Project macro copied to clipboard. Paste into the target '
		+'.HPJ file''s [CONFIG] section or the project macro dialog for '
		+'your authoring tool. Insure that all uses of this macro in '
		+'your project use this form of the macro.'
		,'RegisterRoutine() macro copied...',64);
end;

procedure TWHMB.BCancelClick(Sender: TObject);
begin
	Close;
end;

procedure TWHMB.ClipcopyClick(Sender: TObject);
var i1: integer;
	P1: array [0..255] of char;
begin
	i1 := 0;
{No message content}
	If MsgCaption.Text = '' Then
		i1 := MessageBox(Self.Handle,'No message text has been defined '
			+'for this macro. The messagebox is valid but quite useless. '
			+#10+'Continue anyway?','Macro parameter error detected'
			,MB_ICONQUESTION + MB_YESNO);
	If i1 = ID_NO Then Exit;
{Macro too long}
	If (Use32bit.Checked = False) and (Length(Preview.Text) > 253) then begin
		i1 := MessageBox(Self.Handle,'You have specified a macro longer than '
			+'253 characters for use with 16 bit help. Some authoring tools '
			+'will cheerfully accept macros this long; most will not.'
			+#10#10 + 'Use this macro anyway?'
			,'Potential overlong macro detected'
			,MB_ICONQUESTION + MB_YESNO);
		if i1 = ID_NO then Exit;
	end;
{copy the sucker}
	Preview.SelectAll;
	Preview.CopyToClipboard;
	StrPCopy(P1,'The' + FunctionName + ' macro has been copied to the clipboard. '
		+'Insert into target document or dialog prior to creating a new macro.');
	MessageBox(Self.Handle,P1,'Macro copied to clipboard',64);
end;

procedure TWHMB.MBXTypeChange(Sender: TObject);
begin
	MBFlag2 := MBXType.ItemIndex;
	Update_MB;
end;

procedure TWHMB.Option2Click(Sender: TObject);
begin
	MBMacFlag := 1;
	MacroLabel1.Enabled := True;
	MacroLabel2.Enabled :=False;
	MBMacroString1.Enabled := True;
	MBMacroString2.Enabled := False;
	Update_MB;
end;

procedure TWHMB.Option3Click(Sender: TObject);
begin
	MBMacFlag := 2;
	MacroLabel1.Enabled := True;
	MacroLabel2.Enabled :=True;
	MBMacroString1.Enabled := True;
	MBMacroString2.Enabled := True;
	Update_MB;
end;

procedure TWHMB.Option1Click(Sender: TObject);
begin
	MBMacFlag := 0;
	MacroLabel1.Enabled := False;
	MacroLabel2.Enabled :=False;
	MBMacroString1.Enabled := False;
	MBMacroString2.Enabled := False;
	Update_MB;
end;

procedure TWHMB.CheckBox1Click(Sender: TObject);
begin
	If Checkbox1.Checked = True Then
		FunctionName := 'WHMB' Else
		FunctionName := 'WHMessageBox';
	Update_MB;
end;

procedure TWHMB.HintsOnClick(Sender: TObject);
begin
	If HintsOn.Checked = True Then begin
		Application.ShowHint := True;
		WritePrivateProfileString(Section,'Hints','On',INIFile);
	end else begin
		Application.ShowHint := False;
		WritePrivateProfileString(Section,'Hints','Off',INIFile);
	end;
end;

procedure TWHMB.MsgCaptionExit(Sender: TObject);
begin
	Errorshown := False;
end;

procedure TWHMB.MsgContentExit(Sender: TObject);
begin
	Errorshown := False;
end;

procedure TWHMB.MBMacroString1Exit(Sender: TObject);
begin
	Errorshown := False;
end;

procedure TWHMB.MBMacroString2Exit(Sender: TObject);
begin
	Errorshown := False;
end;

procedure TWHMB.Use32bitClick(Sender: TObject);
begin
	If Use32bit.Checked = True then begin
		Opt321 := '';
		Opt322 := '';
	end else begin
		Opt321 := '`';
		Opt322 := '''';
	end;
	Update_MB;
end;

end.
