unit Broomer;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls,ToolHelp,Menus,Buttons, Balloon;

type
  TBroom1 = class(TForm)
	Label1: TLabel;
	Label2: TLabel;
	ListBox3: TListBox;
	Button6: TButton;
	Button1: TButton;
	Button2: TButton;
	Hotlist: TListBox;
	ListBox1: TListBox;
	Loadlist: TButton;
	LED1: TRadioButton;
	LED2: TRadioButton;
	Label3: TLabel;
	Unload: TButton;
	Bevel1: TBevel;
	Prompts: TCheckBox;
	HintsOn: TCheckBox;
	ListBox4: TListBox;
	Label5: TLabel;
	BalloonHint1: TBalloonHint;
	Usera: TLabel;
	GDIa: TLabel;
	Userp: TLabel;
	GDIp: TLabel;
    Bevel2: TBevel;
	procedure ListBox1Click(Sender: TObject);
	procedure Button1Click(Sender: TObject);
	procedure FormActivate(Sender: TObject);
	procedure Button6Click(Sender: TObject);
	procedure Button2Click(Sender: TObject);
	procedure FormCreate(Sender: TObject);
	procedure LoadlistClick(Sender: TObject);
	procedure HotlistClick(Sender: TObject);
	procedure LED1Click(Sender: TObject);
	procedure LED2Click(Sender: TObject);
	procedure UnloadClick(Sender: TObject);
	procedure PromptsClick(Sender: TObject);
	procedure HintsOnClick(Sender: TObject);
	procedure UseraClick(Sender: TObject);
  private
	{ Private declarations }
	FType: integer;
	procedure SelectType;
	function Checkthelist(Instring: String): Bool;
	procedure Dochecks;
	procedure YieldApp;
	procedure UpdateResourceReadout;
{	procedure DecrementModuleUsage;}
  public
	{ Public declarations }
  end;

var Broom1: TBroom1;
	AppIni: array [byte] of Char;
	KillList: Bool;
	Prompts: Bool;
const Section: array [0..15] of Char = 'Unloading Dock';


implementation

{$R *.DFM}

procedure TBroom1.SelectType;

var
  strTemp    : String[8];
  strName    : String[8];
  strExePath : string[120];
  ModuleEntry     : TModuleEntry;
  FSearchrec : TSearchRec;
  FindResult : integer;
  f, i, w    : integer;

begin{ clear the grid }
  Screen.Cursor := crHourGlass;
  Application.Processmessages;
  i := 1;
  w := 0;
  f := Ftype;
  ModuleEntry.dwSize := SizeOf(ModuleEntry);
  if ModuleFirst(@ModuleEntry) then
	repeat
	  strName := StrPas(ModuleEntry.szModule);
	  strExePath := strpas(ModuleEntry.szExepath);
	  if length(strExePath)>w then
		w := length(strExePath);
	  FindResult := FindFirst(strExePath, faAnyFile, FSearchRec);
	  strTemp := Copy(strExepath, length(strExepath)-2,3);
	  if (f=0) or (uppercase(strTemp) = 'DLL') and (strName<>'') then
	  If UpperCase(ExtractFileExt(strExePath)) = '.DLL' then Listbox1.Items.Add(strExePath);
	until ModuleNext(@ModuleEntry)=false;
  Screen.Cursor := crDefault;
  Broom1.Invalidate;
end; { TForm1.SelectType }


procedure TBroom1.ListBox1Click(Sender: TObject);
var S1,S2: String;
	SkipModule: Bool;
begin
{	Listbox3.Items.Add(Listbox1.Items[Listbox1.Itemindex]);}
	If LED1.Checked = True then begin
		S1 := Listbox1.Items[Listbox1.Itemindex];
		If Hotlist.Items.Count = 0 then SkipModule := False
			else SkipModule := ChecktheList(S1);
		If Skipmodule = False then begin
			Listbox3.Items.Add(S1);
			S2 := ExtractFileName(S1);
			Hotlist.Items.Add(S2);
		end;
	end;
end;

procedure Diag(Sin1,Sin2: String);
var P1,P2: array [byte] of Char;
begin
	MessageBox(GetActivewindow,Strpcopy(P1,Sin1),StrPCopy(P2,Sin2),0);
end;

function TBroom1.Checkthelist(Instring: String): Bool;
var S1: String;
	i1: Integer;
begin
	Result := False;
	S1 := '+';
	i1 := 0;
	While i1 < Listbox3.Items.Count do begin
		S1 := Listbox3.Items[i1];
		If S1 = Instring then begin
			Result := True;
			Exit;
		end;
		Inc(i1);
	End;
end;

procedure TBroom1.Button1Click(Sender: TObject);
var i1: integer;
	P1: array[0..4] of Char;
begin
	If Prompts.Checked = False then Close else begin
		i1 := MessageBox(Self.Handle
			,'Really close Unloading Dock?'
			,'Confirmation',MB_ICONQUESTION + MB_OKCANCEL);
		if i1 = ID_OK then Close;
	end;
end;

procedure TBroom1.FormActivate(Sender: TObject);
begin
	SelectType;
	UpdateResourceReadout;
end;

procedure TBroom1.Button6Click(Sender: TObject);
begin
	Listbox1.Items.Clear;
	SelectType;
	UpdateResourceReadout;
end;

procedure TBroom1.Button2Click(Sender: TObject);
var i1: integer;
	P1,P2: array [byte] of Char;
begin
	If LED2.Checked = True then begin
		If Prompts.Checked = True then MessageBox(Self.Handle
			,'Hotlist unloading is disabled...unable to save.'
			,'Aborting',48);
		Exit;
	end;
{LED1 not checked...are there any DLLs to save?}
	i1 := 0;
	If Listbox3.Items.Count > 0 Then begin
		While i1 < Listbox3.Items.Count do begin
			StrPCopy(P1,'Module' + IntToStr(i1+1));
			StrPCopy(P2,Listbox3.Items[i1]);
			WritePrivateProfileString('Hotlist',P1,P2,AppIni);
			Inc(i1);
		end;
		If Prompts.Checked = True then
			Messagebox(Self.Handle,'Hotlisted DLL filenames have been saved to BROOM.INI.'
				,'Hotlist saved',64);
	end {Listbox3} else begin
		If Prompts.Checked = True then MessageBox(Self.Handle
			,'No DLLs in hotlist...nothing to save','Aborting',48);
	end;
{Update resource readouts}
end;

procedure TBroom1.UpdateResourceReadout;
var ResFree: Word;
begin
	ResFree := GetFreeSystemResources(GFSR_USERRESOURCES);
	Userp.Caption := IntToStr(ResFree) + #37;
	ResFree := GetFreeSystemResources(GFSR_GDIRESOURCES);
	GDIp.Caption := IntToStr(ResFree) + #37;
end;

procedure TBroom1.FormCreate(Sender: TObject);
var P1,P2: array [0..5] of Char;
begin
	Broom1.Font.Name := 'Helv';
	StrPCopy(AppIni,ChangeFileExt(ExpandFileName(Application.Exename),'.INI'));
{Set prompts}
	GetPrivateProfileString(Section,'Prompts','',P1,SizeOf(P1),AppIni);
	If UpperCase(StrPas(P1)) = StrPas('YES') then
		Prompts.Checked := True else Prompts.Checked := False;
{Set options}
	GetPrivateProfileString(Section,'KillHotlist','',P2,SizeOf(P2),AppIni);
	If UpperCase(StrPas(P2)) = StrPas('YES') then begin
		LED1.Checked := True;
		LED2.Checked := False;
	end else begin
		LED2.Checked := True;
		LED1.Checked := False;
	end;
	Dochecks;
{Set hints}
	GetPrivateProfileString(Section,'Hints','',P1,SizeOf(P1),AppIni);
	If StrPas(P1) = StrPas('Off') Then begin
		Application.ShowHint := False;
		Hintson.Checked := False;
	end else begin
		Application.ShowHint := True;
		Hintson.Checked := True;
	End;
end;

procedure TBroom1.LoadlistClick(Sender: TObject);
var i1,i2: integer;
	S2: String;
	P1,P2: array [byte] of Char;
begin
{Don't load if inactive}
	If LED2.Checked = True then begin
		If Prompts.Checked = True then MessageBox(Self.Handle
			,'Hotlist currently inactive. Check the Remove Entire '
			+'Hotlist From Memory option to re-enable hotlist loading.'
			,'Unable to load...aborting',48);
		Exit;
	end;
{OK to proceed}
	Listbox3.Items.Clear;
	Hotlist.Items.Clear;
	i1 := 4;
	i2 := 1;
	While i1 > 3 do begin
		StrPCopy(P1,'Module' + IntToStr(i2));
		i1 := GetPrivateProfileString('Hotlist',P1,'',P2,SizeOf(P2),AppIni);
		if i1 > 3 then begin
			S2 := StrPas(P2);
			Listbox3.Items.Add(S2);
			Hotlist.Items.Add(ExtractFileName(S2));
		end;
		Inc(i2);
	end;
{Verify that we did something}
	If Prompts.Checked = True then begin
		i1 := GetPrivateProfileString('Hotlist','Module1','',P2,SizeOf(P2),AppIni);
		If i1 < 4 then MessageBox(Self.Handle,
			'Hotlist empty...nothing to load','Hotlist not loaded',48)
		else MessageBox(Self.Handle
			,'Last-saved DLL hotlist loaded from BROOM.INI.'
			,'Hotlist loaded',64);
	end;
end;

procedure TBroom1.HotlistClick(Sender: TObject);
begin
	Listbox3.Items.Delete(Hotlist.ItemIndex);
	Hotlist.Items.Delete(Hotlist.ItemIndex);
end;

procedure TBroom1.LED1Click(Sender: TObject);
begin
	Dochecks;
end;

procedure TBroom1.LED2Click(Sender: TObject);
begin
	Dochecks;
end;

procedure TBroom1.UnloadClick(Sender: TObject);
var	strTemp : string[12];
	ModType : string[3];
	i1: integer;
	Module     : TModuleEntry;
	ecode      : integer;
	Done       : boolean;
	P1: array [byte] of Char;
	T1: THandle;
	procedure UpdateModuleVariable;
	begin
		if ModuleFirst(@Module) then
		while (not(Done) and (strTemp<>StrPas(Module.szModule))) do begin
			Application.Processmessages;
			Done := ModuleNext(@Module)=false;
		end;
	end;

begin
{Unload a list}
	If LED1.Checked = True then begin
		i1 := ID_YES;
		If Prompts.Checked = True then
			i1 := MessageBox(Self.Handle,'Unload current list of DLLs?'
			,'Confirming unload',MB_ICONQUESTION + MB_YESNO);
		if i1 = ID_NO Then Exit;
{Haven't quit so we will perform the unload}
		While Listbox3.Items.Count > 0 do begin
			i1 := 1;
			StrPCopy(P1,Listbox3.Items[0]);
			T1 := GetModuleHandle(P1);
			While i1 > 0 do begin
				FreeLibrary(T1);
				i1 := GetModuleUsage(T1);
			end;
			Listbox3.Items.Delete(0);
			Hotlist.Items.Delete(0);
			If Prompts.Checked = True then MessageBox(Self.Handle
				,'Selected DLLs unloaded','Job complete',64);
		end;{while}
	end else begin
		i1 := ID_YES;
{Unload a single module}
		If Prompts.Checked = True then
			i1 := MessageBox(Self.Handle,'Unload selected DLL?'
				,'Confirming unload',MB_ICONQUESTION + MB_YESNO);
		if i1 = ID_NO then Exit;
{Haven't quit so we will perform the unload}
		StrPCopy(P1,Listbox1.Items[Listbox1.Itemindex]);
		T1 := GetModuleHandle(P1);
		i1 := 1;
		While i1 > 0 do begin
			FreeLibrary(T1);
			i1 := GetModuleUsage(T1);
		end;
		If Prompts.Checked = True then MessageBox(Self.Handle
			,'Selected DLL unloaded','Job complete',64);
	end;
{Finally refill the dll list}
	Listbox1.Items.Clear;
	SelectType;
	UpdateResourceReadout;
end;



procedure TBroom1.Dochecks;
var i1: integer;
begin
	If LED1.Checked = True then begin
		Hotlist.Enabled := True;
		WritePrivateProfileString(Section,'KillHotlist','yes',AppIni);
		Hotlist.Items.Clear;
		YieldApp;
		i1 := 0;
		If Listbox4.Items.Count >= 1 Then begin
			While i1 < Listbox3.Items.Count do begin
				Hotlist.Items.Add(Listbox4.Items[i1]);
				Inc(i1);
			end;
		end;
		Led2.Checked := False;
		KillList := True;
		Listbox4.Items.Clear;
	end;
	If Led2.Checked = True then begin
{Fill a temporary list for later}
		i1 := 0;
		If Hotlist.Items.Count >= 1 Then begin
			While i1 < Listbox3.Items.Count do begin
				Listbox4.Items.Add(Hotlist.Items[i1]);
				Inc(i1);
			end;
		end;
		Hotlist.Items.Clear;
		YieldApp;
		Hotlist.Items.Add('(inactive)');
		Led1.Checked := False;
		Killlist := False;
		WritePrivateProfileString(Section,'KillHotlist','no',AppIni);
		Hotlist.Enabled := False;
	end;
end;

procedure TBroom1.PromptsClick(Sender: TObject);
begin
	If Prompts.Checked = True then
		WritePrivateProfileString(Section,'Prompts','yes',AppIni)
	else WritePrivateProfileString(Section,'Prompts','no',AppIni)

end;

procedure TBroom1.YieldApp;
var MSG: TMsg;
	Handle: THandle;
begin
	Handle := 0;
	while PeekMessage(Msg,Handle, 0, 0, PM_REMOVE) = True
		do if(Msg.message = 18)
			then PostQuitMessage(0)	else begin
				TranslateMessage(Msg);
				DispatchMessage(Msg);
		end;
end;




procedure TBroom1.HintsOnClick(Sender: TObject);
begin
	If HintsOn.Checked = True Then begin
		Application.ShowHint := True;
		WritePrivateProfileString(Section,'Hints','On',AppIni);
		end else begin
		Application.ShowHint := False;
		WritePrivateProfileString(Section,'Hints','Off',AppIni);
	end;
end;


procedure TBroom1.UseraClick(Sender: TObject);
begin
	UpdateResourceReadout;
end;

end.



